Evals
List evals
evals.list(**kwargs) -> CursorPage<EvalListResponse>
get /evals
List evaluations for a project.
Parameters
-
after: StringIdentifier for the last eval from the previous pagination request.
-
limit: IntegerNumber of evals to retrieve.
-
order: :asc | :descSort order for evals by timestamp. Use
ascfor ascending order ordescfor descending order.-
:asc -
:desc
-
-
order_by: :created_at | :updated_atEvals can be ordered by creation time or last updated time. Use
created_atfor creation time orupdated_atfor last updated time.-
:created_at -
:updated_at
-
Returns
-
class EvalListResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Example
require "openai"
openai = OpenAI::Client.new(api_key: "My API Key")
page = openai.evals.list
puts(page)
Response
{
"data": [
{
"id": "id",
"created_at": 0,
"data_source_config": {
"schema": {
"foo": "bar"
},
"type": "custom"
},
"metadata": {
"foo": "string"
},
"name": "Chatbot effectiveness Evaluation",
"object": "eval",
"testing_criteria": [
{
"input": [
{
"content": "string",
"role": "user",
"type": "message"
}
],
"labels": [
"string"
],
"model": "model",
"name": "name",
"passing_labels": [
"string"
],
"type": "label_model"
}
]
}
],
"first_id": "first_id",
"has_more": true,
"last_id": "last_id",
"object": "list"
}
Create eval
evals.create(**kwargs) -> EvalCreateResponse
post /evals
Create the structure of an evaluation that can be used to test a model's performance. An evaluation is a set of testing criteria and the config for a data source, which dictates the schema of the data used in the evaluation. After creating an evaluation, you can run it on different models and model parameters. We support several types of graders and datasources. For more information, see the Evals guide.
Parameters
-
data_source_config: Custom{ item_schema, type, include_sample_schema} | Logs{ type, metadata} | StoredCompletions{ type, metadata}The configuration for the data source used for the evaluation runs. Dictates the schema of the data used in the evaluation.
-
class CustomA CustomDataSourceConfig object that defines the schema for the data source used for the evaluation runs. This schema is used to define the shape of the data that will be:
-
Used to define your testing criteria and
-
What data is required when creating a run
-
item_schema: Hash[Symbol, untyped]The json schema for each row in the data source.
-
type: :customThe type of data source. Always
custom.:custom
-
include_sample_schema: boolWhether the eval should expect you to populate the sample namespace (ie, by generating responses off of your data source)
-
-
class LogsA data source config which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc.-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: Hash[Symbol, untyped]Metadata filters for the logs data source.
-
-
class StoredCompletionsDeprecated in favor of LogsDataSourceConfig.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: Hash[Symbol, untyped]Metadata filters for the stored completions data source.
-
-
-
testing_criteria: Array[LabelModel{ input, labels, model, 3 more} | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of graders for all eval runs in this group. Graders can reference variables in the data source using double curly braces notation, like
{{item.variable_name}}. To reference the model's output, use thesamplenamespace (ie,{{sample.output_text}}).-
class LabelModelA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[SimpleInputMessage{ content, role} | EvalItem{ content, role, type}]A list of chat messages forming the prompt or context. May include variable references to the
itemnamespace, ie {{item.name}}.-
class SimpleInputMessage-
content: StringThe content of the message.
-
role: StringThe role of the message (e.g. "system", "assistant", "user").
-
-
class EvalItemA message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
-
labels: Array[String]The labels to classify to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class TextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class PythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class ScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
Returns
-
class EvalCreateResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Example
require "openai"
openai = OpenAI::Client.new(api_key: "My API Key")
eval_ = openai.evals.create(
data_source_config: {item_schema: {foo: "bar"}, type: :custom},
testing_criteria: [
{
input: [{content: "content", role: "role"}],
labels: ["string"],
model: "model",
name: "name",
passing_labels: ["string"],
type: :label_model
}
]
)
puts(eval_)
Response
{
"id": "id",
"created_at": 0,
"data_source_config": {
"schema": {
"foo": "bar"
},
"type": "custom"
},
"metadata": {
"foo": "string"
},
"name": "Chatbot effectiveness Evaluation",
"object": "eval",
"testing_criteria": [
{
"input": [
{
"content": "string",
"role": "user",
"type": "message"
}
],
"labels": [
"string"
],
"model": "model",
"name": "name",
"passing_labels": [
"string"
],
"type": "label_model"
}
]
}
Get an eval
evals.retrieve(eval_id) -> EvalRetrieveResponse
get /evals/{eval_id}
Get an evaluation by ID.
Parameters
eval_id: String
Returns
-
class EvalRetrieveResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Example
require "openai"
openai = OpenAI::Client.new(api_key: "My API Key")
eval_ = openai.evals.retrieve("eval_id")
puts(eval_)
Response
{
"id": "id",
"created_at": 0,
"data_source_config": {
"schema": {
"foo": "bar"
},
"type": "custom"
},
"metadata": {
"foo": "string"
},
"name": "Chatbot effectiveness Evaluation",
"object": "eval",
"testing_criteria": [
{
"input": [
{
"content": "string",
"role": "user",
"type": "message"
}
],
"labels": [
"string"
],
"model": "model",
"name": "name",
"passing_labels": [
"string"
],
"type": "label_model"
}
]
}
Update an eval
evals.update(eval_id, **kwargs) -> EvalUpdateResponse
post /evals/{eval_id}
Update certain properties of an evaluation.
Parameters
-
eval_id: String -
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringRename the evaluation.
Returns
-
class EvalUpdateResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Example
require "openai"
openai = OpenAI::Client.new(api_key: "My API Key")
eval_ = openai.evals.update("eval_id")
puts(eval_)
Response
{
"id": "id",
"created_at": 0,
"data_source_config": {
"schema": {
"foo": "bar"
},
"type": "custom"
},
"metadata": {
"foo": "string"
},
"name": "Chatbot effectiveness Evaluation",
"object": "eval",
"testing_criteria": [
{
"input": [
{
"content": "string",
"role": "user",
"type": "message"
}
],
"labels": [
"string"
],
"model": "model",
"name": "name",
"passing_labels": [
"string"
],
"type": "label_model"
}
]
}
Delete an eval
evals.delete(eval_id) -> EvalDeleteResponse
delete /evals/{eval_id}
Delete an evaluation.
Parameters
eval_id: String
Returns
-
class EvalDeleteResponse-
deleted: bool -
eval_id: String -
object: String
-
Example
require "openai"
openai = OpenAI::Client.new(api_key: "My API Key")
eval_ = openai.evals.delete("eval_id")
puts(eval_)
Response
{
"deleted": true,
"eval_id": "eval_abc123",
"object": "eval.deleted"
}
Domain Types
Eval Custom Data Source Config
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
Eval Stored Completions Data Source Config
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
Eval List Response
-
class EvalListResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Eval Create Response
-
class EvalCreateResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Eval Retrieve Response
-
class EvalRetrieveResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Eval Update Response
-
class EvalUpdateResponseAn Eval object with a data source config and testing criteria. An Eval represents a task to be done for your LLM integration. Like:
-
Improve the quality of my chatbot
-
See how well my chatbot handles customer support
-
Check if o4-mini is better at my usecase than gpt-4o
-
id: StringUnique identifier for the evaluation.
-
created_at: IntegerThe Unix timestamp (in seconds) for when the eval was created.
-
data_source_config: EvalCustomDataSourceConfig | Logs{ schema, type, metadata} | EvalStoredCompletionsDataSourceConfigConfiguration of data sources used in runs of the evaluation.
-
class EvalCustomDataSourceConfigA CustomDataSourceConfig which specifies the schema of your
itemand optionallysamplenamespaces. The response schema defines the shape of the data that will be:-
Used to define your testing criteria and
-
What data is required when creating a run
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :customThe type of data source. Always
custom.:custom
-
-
class LogsA LogsDataSourceConfig which specifies the metadata property of your logs query. This is usually metadata like
usecase=chatbotorprompt-version=v2, etc. The schema returned by this data source config is used to defined what variables are available in your evals.itemandsampleare both defined when using this data source config.-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :logsThe type of data source. Always
logs.:logs
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
class EvalStoredCompletionsDataSourceConfigDeprecated in favor of LogsDataSourceConfig.
-
schema: Hash[Symbol, untyped]The json schema for the run data source items. Learn how to build JSON schemas here.
-
type: :stored_completionsThe type of data source. Always
stored_completions.:stored_completions
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
-
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
name: StringThe name of the evaluation.
-
object: :evalThe object type.
:eval
-
testing_criteria: Array[LabelModelGrader | StringCheckGrader | TextSimilarityGrader & { pass_threshold} | 2 more]A list of testing criteria.
-
class LabelModelGraderA LabelModelGrader object which uses a model to assign labels to each item in the evaluation.
-
input: Array[Input{ content, role, type}]-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
labels: Array[String]The labels to assign to each item in the evaluation.
-
model: StringThe model to use for the evaluation. Must support structured outputs.
-
name: StringThe name of the grader.
-
passing_labels: Array[String]The labels that indicate a passing result. Must be a subset of labels.
-
type: :label_modelThe object type, which is always
label_model.:label_model
-
-
class StringCheckGraderA StringCheckGrader object that performs a string comparison between input and reference using a specified operation.
-
input: StringThe input text. This may include template strings.
-
name: StringThe name of the grader.
-
operation: :eq | :ne | :like | :ilikeThe string check operation to perform. One of
eq,ne,like, orilike.-
:eq -
:ne -
:like -
:ilike
-
-
reference: StringThe reference text. This may include template strings.
-
type: :string_checkThe object type, which is always
string_check.:string_check
-
-
class EvalGraderTextSimilarityA TextSimilarityGrader object which grades text based on similarity metrics.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderPythonA PythonGrader object that runs a python script on the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
class EvalGraderScoreModelA ScoreModelGrader object that uses a model to assign a score to the input.
-
pass_threshold: FloatThe threshold for the score.
-
-
-
Eval Delete Response
-
class EvalDeleteResponse-
deleted: bool -
eval_id: String -
object: String
-
Runs
Get eval runs
evals.runs.list(eval_id, **kwargs) -> CursorPage<RunListResponse>
get /evals/{eval_id}/runs
Get a list of runs for an evaluation.
Parameters
-
eval_id: String -
after: StringIdentifier for the last run from the previous pagination request.
-
limit: IntegerNumber of runs to retrieve.
-
order: :asc | :descSort order for runs by timestamp. Use
ascfor ascending order ordescfor descending order. Defaults toasc.-
:asc -
:desc
-
-
status: :queued | :in_progress | :completed | 2 moreFilter runs by status. One of
queued|in_progress|failed|completed|canceled.-
:queued -
:in_progress -
:completed -
:canceled -
:failed
-
Returns
-
class RunListResponseA schema representing an evaluation run.
-
id: StringUnique identifier for the evaluation run.
-
created_at: IntegerUnix timestamp (in seconds) when the evaluation run was created.
-
data_source: CreateEvalJSONLRunDataSource | CreateEvalCompletionsRunDataSource | Responses{ source, type, input_messages, 2 more}Information about the run's data source.
-
class CreateEvalJSONLRunDataSourceA JsonlRunDataSource object with that specifies a JSONL file that matches the eval
-
source: FileContent{ content, type} | FileID{ id, type}Determines what populates the
itemnamespace in the data source.-
class FileContent-
content: Array[Content{ item, sample}]The content of the jsonl file.
-
item: Hash[Symbol, untyped] -
sample: Hash[Symbol, untyped]
-
-
type: :file_contentThe type of jsonl source. Always
file_content.:file_content
-
-
class FileID-
id: StringThe identifier of the file.
-
type: :file_idThe type of jsonl source. Always
file_id.:file_id
-
-
-
type: :jsonlThe type of data source. Always
jsonl.:jsonl
-
-
class CreateEvalCompletionsRunDataSourceA CompletionsRunDataSource object describing a model sampling configuration.
-
source: FileContent{ content, type} | FileID{ id, type} | StoredCompletions{ type, created_after, created_before, 3 more}Determines what populates the
itemnamespace in this run's data source.-
class FileContent-
content: Array[Content{ item, sample}]The content of the jsonl file.
-
item: Hash[Symbol, untyped] -
sample: Hash[Symbol, untyped]
-
-
type: :file_contentThe type of jsonl source. Always
file_content.:file_content
-
-
class FileID-
id: StringThe identifier of the file.
-
type: :file_idThe type of jsonl source. Always
file_id.:file_id
-
-
class StoredCompletionsA StoredCompletionsRunDataSource configuration describing a set of filters
-
type: :stored_completionsThe type of source. Always
stored_completions.:stored_completions
-
created_after: IntegerAn optional Unix timestamp to filter items created after this time.
-
created_before: IntegerAn optional Unix timestamp to filter items created before this time.
-
limit: IntegerAn optional maximum number of items to return.
-
metadata: MetadataSet of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard.
Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters.
-
model: StringAn optional model to filter by (e.g., 'gpt-4o').
-
-
-
type: :completionsThe type of run data source. Always
completions.:completions
-
input_messages: Template{ template, type} | ItemReference{ item_reference, type}Used when sampling from a model. Dictates the structure of the messages passed into the model. Can either be a reference to a prebuilt trajectory (ie,
item.input_trajectory), or a template with variable references to theitemnamespace.-
class Template-
template: Array[EasyInputMessage | EvalItem{ content, role, type}]A list of chat messages forming the prompt or context. May include variable references to the
itemnamespace, ie {{item.name}}.-
class EasyInputMessageA message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: String | ResponseInputMessageContentListText, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.
-
String = StringA text input to the model.
-
ResponseInputMessageContentList = Array[ResponseInputContent]A list of one or many input items to the model, containing different content types.
-
class ResponseInputTextA text input to the model.
-
text: StringThe text input to the model.
-
type: :input_textThe type of the input item. Always
input_text.:input_text
-
-
class ResponseInputImageAn image input to the model. Learn about image inputs.
-
detail: :low | :high | :auto | :originalThe detail level of the image to be sent to the model. One of
high,low,auto, ororiginal. Defaults toauto.-
:low -
:high -
:auto -
:original
-
-
type: :input_imageThe type of the input item. Always
input_image.:input_image
-
file_id: StringThe ID of the file to be sent to the model.
-
image_url: StringThe URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
-
-
class ResponseInputFileA file input to the model.
-
type: :input_fileThe type of the input item. Always
input_file.:input_file
-
detail: :low | :highThe detail level of the file to be sent to the model. Use
lowfor the default rendering behavior, orhighto render the file at higher quality. Defaults tolow.-
:low -
:high
-
-
file_data: StringThe content of the file to be sent to the model.
-
file_id: StringThe ID of the file to be sent to the model.
-
file_url: StringThe URL of the file to be sent to the model.
-
filename: StringThe name of the file to be sent to the model.
-
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
phase: :commentary | :final_answerLabels an
assistantmessage as intermediate commentary (commentary) or the final answer (final_answer). For models likegpt-5.3-codexand beyond, when sending follow-up requests, preserve and resend phase on all assistant messages — dropping it can degrade performance. Not used for user messages.-
:commentary -
:final_answer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
class EvalItemA message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
input_audio: InputAudio{ data, format_}-
data: StringBase64-encoded audio data.
-
format_: :mp3 | :wavThe format of the audio data. Currently supported formats are
mp3andwav.-
:mp3 -
:wav
-
-
-
type: :input_audioThe type of the input item. Always
input_audio.:input_audio
-
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
-
type: :templateThe type of input messages. Always
template.:template
-
-
class ItemReference-
item_reference: StringA reference to a variable in the
itemnamespace. Ie, "item.input_trajectory" -
type: :item_referenceThe type of input messages. Always
item_reference.:item_reference
-
-
-
model: StringThe name of the model to use for generating completions (e.g. "o3-mini").
-
sampling_params: SamplingParams{ max_completion_tokens, reasoning_effort, response_format, 4 more}-
max_completion_tokens: IntegerThe maximum number of tokens in the generated output.
-
reasoning_effort: ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high, andxhigh. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.-
gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1. -
All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. -
The
gpt-5-promodel defaults to (and only supports)highreasoning effort. -
xhighis supported for all models aftergpt-5.1-codex-max. -
:none -
:minimal -
:low -
:medium -
:high -
:xhigh
-
-
response_format: ResponseFormatText | ResponseFormatJSONSchema | ResponseFormatJSONObjectAn object specifying the format that the model must output.
Setting to
{ "type": "json_schema", "json_schema": {...} }enables Structured Outputs which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.Setting to
{ "type": "json_object" }enables the older JSON mode, which ensures the message the model generates is valid JSON. Usingjson_schemais preferred for models that support it.-
class ResponseFormatTextDefault response format. Used to generate text responses.
-
type: :textThe type of response format being defined. Always
text.:text
-
-
class ResponseFormatJSONSchemaJSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
json_schema: JSONSchema{ name, description, schema, strict}Structured Outputs configuration options, including a JSON Schema.
-
name: StringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: StringA description of what the response format is for, used by the model to determine how to respond in the format.
-
schema: Hash[Symbol, untyped]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
strict: boolWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
type: :json_schemaThe type of response format being defined. Always
json_schema.:json_schema
-
-
class ResponseFormatJSONObjectJSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.-
type: :json_objectThe type of response format being defined. Always
json_object.:json_object
-
-
-
seed: IntegerA seed value to initialize the randomness, during sampling.
-
temperature: FloatA higher temperature increases randomness in the outputs.
-
tools: Array[ChatCompletionFunctionTool]A list of tools the model may call. Currently, only functions are supported as a tool. Use this to provide a list of functions the model may generate JSON inputs for. A max of 128 functions are supported.
-
function: FunctionDefinition-
name: StringThe name of the function to be called. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
description: StringA description of what the function does, used by the model to choose when and how to call the function.
-
parameters: FunctionParametersThe parameters the functions accepts, described as a JSON Schema object. See the guide for examples, and the JSON Schema reference for documentation about the format.
Omitting
parametersdefines a function with an empty parameter list. -
strict: boolWhether to enable strict schema adherence when generating the function call. If set to true, the model will follow the exact schema defined in the
parametersfield. Only a subset of JSON Schema is supported whenstrictistrue. Learn more about Structured Outputs in the function calling guide.
-
-
type: :functionThe type of the tool. Currently, only
functionis supported.:function
-
-
top_p: FloatAn alternative to temperature for nucleus sampling; 1.0 includes all tokens.
-
-
-
class ResponsesA ResponsesRunDataSource object describing a model sampling configuration.
-
source: FileContent{ content, type} | FileID{ id, type} | Responses{ type, created_after, created_before, 8 more}Determines what populates the
itemnamespace in this run's data source.-
class FileContent-
content: Array[Content{ item, sample}]The content of the jsonl file.
-
item: Hash[Symbol, untyped] -
sample: Hash[Symbol, untyped]
-
-
type: :file_contentThe type of jsonl source. Always
file_content.:file_content
-
-
class FileID-
id: StringThe identifier of the file.
-
type: :file_idThe type of jsonl source. Always
file_id.:file_id
-
-
class ResponsesA EvalResponsesSource object describing a run data source configuration.
-
type: :responsesThe type of run data source. Always
responses.:responses
-
created_after: IntegerOnly include items created after this timestamp (inclusive). This is a query parameter used to select responses.
-
created_before: IntegerOnly include items created before this timestamp (inclusive). This is a query parameter used to select responses.
-
instructions_search: StringOptional string to search the 'instructions' field. This is a query parameter used to select responses.
-
metadata: untypedMetadata filter for the responses. This is a query parameter used to select responses.
-
model: StringThe name of the model to find responses for. This is a query parameter used to select responses.
-
reasoning_effort: ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high, andxhigh. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1.- All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. - The
gpt-5-promodel defaults to (and only supports)highreasoning effort. xhighis supported for all models aftergpt-5.1-codex-max.
-
temperature: FloatSampling temperature. This is a query parameter used to select responses.
-
tools: Array[String]List of tool names. This is a query parameter used to select responses.
-
top_p: FloatNucleus sampling parameter. This is a query parameter used to select responses.
-
users: Array[String]List of user identifiers. This is a query parameter used to select responses.
-
-
-
type: :responsesThe type of run data source. Always
responses.:responses
-
input_messages: Template{ template, type} | ItemReference{ item_reference, type}Used when sampling from a model. Dictates the structure of the messages passed into the model. Can either be a reference to a prebuilt trajectory (ie,
item.input_trajectory), or a template with variable references to theitemnamespace.-
class Template-
template: Array[ChatMessage{ content, role} | EvalItem{ content, role, type}]A list of chat messages forming the prompt or context. May include variable references to the
itemnamespace, ie {{item.name}}.-
class ChatMessage-
content: StringThe content of the message.
-
role: StringThe role of the message (e.g. "system", "assistant", "user").
-
-
class EvalItemA message input to the model with a role indicating instruction following hierarchy. Instructions given with the
developerorsystemrole take precedence over instructions given with theuserrole. Messages with theassistantrole are presumed to have been generated by the model in previous interactions.-
content: String | ResponseInputText | OutputText{ text, type} | 3 moreInputs to the model - can contain template strings. Supports text, output text, input images, and input audio, either as a single item or an array of items.
-
String = StringA text input to the model.
-
class ResponseInputTextA text input to the model.
-
class OutputTextA text output from the model.
-
text: StringThe text output from the model.
-
type: :output_textThe type of the output text. Always
output_text.:output_text
-
-
class InputImageAn image input block used within EvalItem content arrays.
-
image_url: StringThe URL of the image input.
-
type: :input_imageThe type of the image input. Always
input_image.:input_image
-
detail: StringThe detail level of the image to be sent to the model. One of
high,low, orauto. Defaults toauto.
-
-
class ResponseInputAudioAn audio input to the model.
-
GraderInputs = Array[GraderInputItem]A list of inputs, each of which may be either an input text, output text, input image, or input audio object.
-
-
role: :user | :assistant | :system | :developerThe role of the message input. One of
user,assistant,system, ordeveloper.-
:user -
:assistant -
:system -
:developer
-
-
type: :messageThe type of the message input. Always
message.:message
-
-
-
type: :templateThe type of input messages. Always
template.:template
-
-
class ItemReference-
item_reference: StringA reference to a variable in the
itemnamespace. Ie, "item.name" -
type: :item_referenceThe type of input messages. Always
item_reference.:item_reference
-
-
-
model: StringThe name of the model to use for generating completions (e.g. "o3-mini").
-
sampling_params: SamplingParams{ max_completion_tokens, reasoning_effort, seed, 4 more}-
max_completion_tokens: IntegerThe maximum number of tokens in the generated output.
-
reasoning_effort: ReasoningEffortConstrains effort on reasoning for reasoning models. Currently supported values are
none,minimal,low,medium,high, andxhigh. Reducing reasoning effort can result in faster responses and fewer tokens used on reasoning in a response.gpt-5.1defaults tonone, which does not perform reasoning. The supported reasoning values forgpt-5.1arenone,low,medium, andhigh. Tool calls are supported for all reasoning values in gpt-5.1.- All models before
gpt-5.1default tomediumreasoning effort, and do not supportnone. - The
gpt-5-promodel defaults to (and only supports)highreasoning effort. xhighis supported for all models aftergpt-5.1-codex-max.
-
seed: IntegerA seed value to initialize the randomness, during sampling.
-
temperature: FloatA higher temperature increases randomness in the outputs.
-
text: Text{ format_}Configuration options for a text response from the model. Can be plain text or structured JSON data. Learn more:
-
format_: ResponseFormatTextConfigAn object specifying the format that the model must output.
Configuring
{ "type": "json_schema" }enables Structured Outputs, which ensures the model will match your supplied JSON schema. Learn more in the Structured Outputs guide.The default format is
{ "type": "text" }with no additional options.Not recommended for gpt-4o and newer models:
Setting to
{ "type": "json_object" }enables the older JSON mode, which ensures the message the model generates is valid JSON. Usingjson_schemais preferred for models that support it.-
class ResponseFormatTextDefault response format. Used to generate text responses.
-
class ResponseFormatTextJSONSchemaConfigJSON Schema response format. Used to generate structured JSON responses. Learn more about Structured Outputs.
-
name: StringThe name of the response format. Must be a-z, A-Z, 0-9, or contain underscores and dashes, with a maximum length of 64.
-
schema: Hash[Symbol, untyped]The schema for the response format, described as a JSON Schema object. Learn how to build JSON schemas here.
-
type: :json_schemaThe type of response format being defined. Always
json_schema.:json_schema
-
description: StringA description of what the response format is for, used by the model to determine how to respond in the format.
-
strict: boolWhether to enable strict schema adherence when generating the output. If set to true, the model will always follow the exact schema defined in the
schemafield. Only a subset of JSON Schema is supported whenstrictistrue. To learn more, read the Structured Outputs guide.
-
-
class ResponseFormatJSONObjectJSON object response format. An older method of generating JSON responses. Using
json_schemais recommended for models that support it. Note that the model will not generate JSON without a system or user message instructing it to do so.
-
-
tools: Array[Tool]An array of tools the model may call while generating a response. You can specify which tool to use by setting the
tool_choiceparameter.The two categories of tools you can provide the model are:
-
Built-in tools: Tools that are provided by OpenAI that extend the model's capabilities, like web search or file search. Learn more about built-in tools.
-
Function calls (custom tools): Functions that are defined by you, enabling the model to call your own code. Learn more about function calling.
-
class FunctionToolDefines a function in your own code the model can choose to call. Learn more about function calling.
-
name: StringThe name of the function to call.
-
parameters: Hash[Symbol, untyped]A JSON schema object describing the parameters of the function.
-
strict: boolWhether to enforce strict parameter validation. Default
true. -
type: :functionThe type of the function tool. Always
function.:function
-
defer_loading: boolWhether this function is deferred and loaded via tool search.
-
description: StringA description of the function. Used by the model to determine whether or not to call the function.
-
-
class FileSearchToolA tool that searches for relevant content from uploaded files. Learn more about the file search tool.
-
type: :file_searchThe type of the file search tool. Always
file_search.:file_search
-
vector_store_ids: Array[String]The IDs of the vector stores to search.
-
filters: ComparisonFilter | CompoundFilterA filter to apply.
-
class ComparisonFilterA filter used to compare a specified attribute key to a given value using a defined comparison operation.
-
key: StringThe key to compare against the value.
-
type: :eq | :ne | :gt | 5 moreSpecifies the comparison operator:
eq,ne,gt,gte,lt,lte,in,nin.-
eq: equals -
ne: not equal -
gt: greater than -
gte: greater than or equal -
lt: less than -
lte: less than or equal -
in: in -
nin: not in -
:eq -
:ne -
:gt -
:gte -
:lt -
:lte -
:in -
:nin
-
-
value: String | Float | bool | Array[String | Float]The value to compare against the attribute key; supports string, number, or boolean types.
-
String = String -
Float = Float -
UnionMember2 = bool -
UnionMember3 = Array[String | Float]-
String = String -
Float = Float
-
-
-
-
class CompoundFilterCombine multiple filters using
andoror.-
filters: Array[ComparisonFilter | untyped]Array of filters to combine. Items can be
ComparisonFilterorCompoundFilter.-
class ComparisonFilterA filter used to compare a specified attribute key to a given value using a defined comparison operation.
-
UnionMember1 = untyped
-
-
type: :and | :orType of operation:
andoror.-
:and -
:or
-
-
-
-
max_num_results: IntegerThe maximum number of results to return. This number should be between 1 and 50 inclusive.
-
ranking_options: RankingOptions{ hybrid_search, ranker, score_threshold}Ranking options for search.
-
hybrid_search: HybridSearch{ embedding_weight, text_weight}Weights that control how reciprocal rank fusion balances semantic embedding matches versus sparse keyword matches when hybrid search is enabled.
-
embedding_weight: FloatThe weight of the embedding in the reciprocal ranking fusion.
-
text_weight: FloatThe weight of the text in the reciprocal ranking fusion.
-
-
ranker: :auto | :"default-2024-11-15"The ranker to use for the file search.
-
:auto -
:"default-2024-11-15"
-
-
score_threshold: FloatThe score threshold for the file search, a number between 0 and 1. Numbers closer to 1 will attempt to return only the most relevant results, but may return fewer results.
-
-
-
class ComputerToolA tool that controls a virtual computer. Learn more about the computer tool.
-
type: :computerThe type of the computer tool. Always
computer.:computer
-
-
class ComputerUsePreviewToolA tool that controls a virtual computer. Learn more about the computer tool.
-
display_height: IntegerThe height of the computer display.
-
display_width: IntegerThe width of the computer display.
-
environment: :windows | :mac | :linux | 2 moreThe type of computer environment to control.
-
:windows -
:mac -
:linux -
:ubuntu -
:browser
-
-
type: :computer_use_previewThe type of the computer use tool. Always
computer_use_preview.:computer_use_preview
-
-
class WebSearchToolSearch the Internet for sources related to the prompt. Learn more about the web search tool.
-
type: :web_search | :web_search_2025_08_26The type of the web search tool. One of
web_searchorweb_search_2025_08_26.-
:web_search -
:web_search_2025_08_26
-
-
filters: Filters{ allowed_domains}Filters for the search.
-
allowed_domains: Array[String]Allowed domains for the search. If not provided, all domains are allowed. Subdomains of the provided domains are allowed as well.
Example:
["pubmed.ncbi.nlm.nih.gov"]
-
-
search_context_size: :low | :medium | :highHigh level guidance for the amount of context window space to use for the search. One of
low,medium, orhigh.mediumis the default.-
:low -
:medium -
:high
-
-
user_location: UserLocation{ city, country, region, 2 more}The approximate location of the user.
-
city: StringFree text input for the city of the user, e.g.
San Francisco. -
country: StringThe two-letter ISO country code of the user, e.g.
US. -
region: StringFree text input for the region of the user, e.g.
California. -
timezone: StringThe IANA timezone of the user, e.g.
America/Los_Angeles. -
type: :approximateThe type of location approximation. Always
approximate.:approximate
-
-
-
class McpGive the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
-
server_label: StringA label for this MCP server, used to identify it in tool calls.
-
type: :mcpThe type of the MCP tool. Always
mcp.:mcp
-
allowed_tools: Array[String] | McpToolFilter{ read_only, tool_names}List of allowed tool names or a filter object.
-
McpAllowedTools = Array[String]A string array of allowed tool names
-
class McpToolFilterA filter object to specify which tools are allowed.
-
read_only: boolIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: Array[String]List of allowed tool names.
-
-
-
authorization: StringAn OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
-
connector_id: :connector_dropbox | :connector_gmail | :connector_googlecalendar | 5 moreIdentifier for service connectors, like those available in ChatGPT. One of
server_urlorconnector_idmust be provided. Learn more about service connectors here.Currently supported
connector_idvalues are:-
Dropbox:
connector_dropbox -
Gmail:
connector_gmail -
Google Calendar:
connector_googlecalendar -
Google Drive:
connector_googledrive -
Microsoft Teams:
connector_microsoftteams -
Outlook Calendar:
connector_outlookcalendar -
Outlook Email:
connector_outlookemail -
SharePoint:
connector_sharepoint -
:connector_dropbox -
:connector_gmail -
:connector_googlecalendar -
:connector_googledrive -
:connector_microsoftteams -
:connector_outlookcalendar -
:connector_outlookemail -
:connector_sharepoint
-
-
defer_loading: boolWhether this MCP tool is deferred and discovered via tool search.
-
headers: Hash[Symbol, String]Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
-
require_approval: McpToolApprovalFilter{ always, never} | :always | :neverSpecify which of the MCP server's tools require approval.
-
class McpToolApprovalFilterSpecify which of the MCP server's tools require approval. Can be
always,never, or a filter object associated with tools that require approval.-
always: Always{ read_only, tool_names}A filter object to specify which tools are allowed.
-
read_only: boolIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: Array[String]List of allowed tool names.
-
-
never: Never{ read_only, tool_names}A filter object to specify which tools are allowed.
-
read_only: boolIndicates whether or not a tool modifies data or is read-only. If an MCP server is annotated with
readOnlyHint, it will match this filter. -
tool_names: Array[String]List of allowed tool names.
-
-
-
McpToolApprovalSetting = :always | :neverSpecify a single approval policy for all tools. One of
alwaysornever. When set toalways, all tools will require approval. When set tonever, all tools will not require approval.-
:always -
:never
-
-
-
server_description: StringOptional description of the MCP server, used to provide more context.
-
server_url: StringThe URL for the MCP server. One of
server_urlorconnector_idmust be provided.
-
-
class CodeInterpreterA tool that runs Python code to help generate a response to a prompt.
-
container: String | CodeInterpreterToolAuto{ type, file_ids, memory_limit, network_policy}The code interpreter container. Can be a container ID or an object that specifies uploaded file IDs to make available to your code, along with an optional
memory_limitsetting.-
String = StringThe container ID.
-
[...]
